#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>

int main(int argc, char *argv[]) {
  if (argc != 2)
  {
    printf("usage: %s FILENAME\n", argv[0]);
    return(-1);
  }

  pid_t pid = fork();

  if (pid == 0) {
    struct flock lock;
    lock.l_whence = SEEK_SET;
    lock.l_type   = F_WRLCK;
    lock.l_start  = 0;
    lock.l_len    = 0;
    lock.l_pid    = getpid();

    int fd = open(argv[1], O_RDWR|O_CREAT|O_TRUNC, 0666);
    int rc = fcntl(fd, F_SETLK, &lock);
    if (rc != 0)
    {
      perror("c_fcntl: ");
      return(rc);
    }
    else
    {
      char *args[] = {"/bin/sleep", "5", NULL};
      execv("/bin/sleep", args);
      return(0); // will never reach
    }
  }

  int status;
  if (pid == waitpid(pid, &status, 0))
    return(WEXITSTATUS(status));
  else
    return(-1);
}
